#!/bin/bash
# script pour renommer plusieurs fichiers à la manière de windows.
#
# Copyright (C) 26 Juil. 2011, Rombeaut Rodolphe
# http://scriptam.over-blog.com/
# Released into the public domain.

OUTPUT="NEWNAME_(001).EXT"

cd $1
shift

NUMFILES=${#@}
DECOMPTEZEROS=${#NUMFILES}

NEWNAME=$(zenity --entry \
--title "Multi-rename" \
--text "Choisissez le nouveau nom pour ces dossiers.
L'affichage sera du type : ${OUTPUT}")
[ $? -ne 0 ] && {
    exit 1
}

NUM=0
for FILE in ${@}
do
    EXT=${FILE##*.}
    [ ${EXT} == ${FILE} -o ${#EXT} -gt 4 ] && EXT=""
    i=$NUM
    [ $NUM -eq 0 ] && COPY="" || COPY=$(printf "_(%0${DECOMPTEZEROS}i)" $i)
    
    [ -f ${NEWNAME}${COPY}${EXT:+.}${EXT} ] && { 
        zenity --info --title="Erreur" --text="le fichier ${NEWNAME}${COPY}${EXT:+.}${EXT} existe déjà. Annulation."
        exit 1
    } || {
        mv ${FILE} ${NEWNAME}${COPY}${EXT:+.}${EXT}
    }
    
    ((NUM++))
done

exit 0
